/*
 * Copyright (c) 1990, 1991 Stanford University
 *
 * Permission to use, copy, modify, and distribute this software and 
 * its documentation for any purpose is hereby granted without fee, provided
 * that (i) the above copyright notices and this permission notice appear in
 * all copies of the software and related documentation, and (ii) the name
 * Stanford may not be used in any advertising or publicity relating to
 * the software without the specific, prior written permission of
 * Stanford.
 * 
 * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
 * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
 * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
 *
 * IN NO EVENT SHALL STANFORD BE LIABLE FOR ANY SPECIAL, INCIDENTAL,
 * INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND, OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER OR NOT
 * ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF LIABILITY,
 * ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
 * SOFTWARE.
 */

/* $Header: /Source/Media/collab/vcrEdit/RCS/vcrEditProtocol.h,v 0.11 91/08/21 14:34:12 lim Exp Locker: drapeau $ */
/* $Log:	vcrEditProtocol.h,v $
 * Revision 0.11  91/08/21  14:34:12  lim
 * Added GetAppIcon().
 * 
 * Revision 0.10  91/07/16  16:17:58  lim
 * Initial revision.
 * 
 * Revision 0.13  91/06/29  12:12:10  lim
 * Added new protocol calls - Halt, Pause, Resume, Hide, Show.
 * 
 * Revision 0.12  91/06/05  10:14:09  lim
 * Included copyright.
 * 
 * Revision 0.11  1991/05/09  22:22:36  lim
 * *** empty log message ***
 *
 * Revision 0.10  1991/04/04  23:36:43  lim
 * Initial revision.
 * */

void InitNetwork();
void OpenDoc();
void SetSelection();
void PerformSelection();
char ** GetDoc();
Selection * GetSelection();
void HaltSelection();
void PauseSelection();
void ResumeSelection();
void HideApplication();
void ShowApplication();
IconData* GetAppIcon();

static char lphrcsid[] = "$Header: /Source/Media/collab/vcrEdit/RCS/vcrEditProtocol.h,v 0.11 91/08/21 14:34:12 lim Exp Locker: drapeau $";

Sender* sender;
Receiver* receiver;
